#!/bin/bash

# uninstall logic for M3X Backup Online PRO 6.19.0.0
# The root privilege is required to uninstall the application

###############################################################################
#             S H U T - D O W N                 S E R V I C E S               #
###############################################################################

# Shutdown Scheduler
if [ -e "/Applications/M3X Backup Online PRO/ipc/Scheduler/running" ]; then
    echo "Shutdown Scheduler for M3X Backup Online PRO"
    touch "/Applications/M3X Backup Online PRO/ipc/Scheduler/stop"
    echo "Wait 5 seconds before Scheduler exits"
    sleep 5
fi

# Shutdown AutoUpdateAgent
if [ -e "/Applications/M3X Backup Online PRO/aua/bin" ]; then
    echo "Shutdown AutoUpdateAgent for M3X Backup Online PRO"
    sh "/Applications/M3X Backup Online PRO/aua/bin/shutdown.sh"
    echo "Wait 5 seconds before AutoUpdateAgent exits"
    sleep 5
fi

###############################################################################
#        T A S K K I L L       A L L      J A V A       P R O C E S S         #
###############################################################################

# Kill all running process
sh "/Applications/M3X Backup Online PRO/bin/taskkill" "/Applications/M3X Backup Online PRO/BackupManager.app"
sh "/Applications/M3X Backup Online PRO/bin/taskkill" "/Applications/M3X Backup Online PRO/bin/BackupManager.app"
sh "/Applications/M3X Backup Online PRO/bin/taskkill" "/Applications/M3X Backup Online PRO/jvm/bin/java"
sh "/Applications/M3X Backup Online PRO/bin/taskkill" "/Applications/M3X Backup Online PRO/aua/jvm/bin/java"

###############################################################################
#                 R E M O V E                   S E R V I C E S               #
###############################################################################

# Remove Scheduler
if [ -e "/Library/StartupItems/M3XBackupOnlinePRO" ]; then
    echo "Remove Scheduler for M3X Backup Online PRO from service"
    rm -rf "/Library/StartupItems/M3XBackupOnlinePRO"
fi

# Remove AutoUpdateAgent
if [ -e "/Library/StartupItems/M3XBackupOnlinePRO-AutoUpdate" ]; then
    echo "Remove AutoUpdateAgent for M3X Backup Online PRO from service"
    rm -rf "/Library/StartupItems/M3XBackupOnlinePRO-AutoUpdate"
fi

###############################################################################
#      R E M O V E        U S E R         D E S K T O P      L I N K          #
###############################################################################

# Remove Desktop Symbolic Link
find /Users -name Desktop -type d -maxdepth 3 -mindepth 2 | while read DESKTOP_PATH;
do
    if [ -e "${DESKTOP_PATH}/M3XBackupOnlinePRO" ]; then
        echo "Remove Desktop Link M3XBackupOnlinePRO from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/M3XBackupOnlinePRO"
        echo "Removed M3X Backup Online PRO Desktop Link"
    fi

    if [ -e "${DESKTOP_PATH}/M3X Backup Online PRO" ]; then
        echo "Remove Desktop Link M3X Backup Online PRO from path ${DESKTOP_PATH}"
        rm -f "${DESKTOP_PATH}/M3X Backup Online PRO"
        echo "Removed M3X Backup Online PRO Desktop Link"
    fi
done

###############################################################################
#        R E M O V E           A P P L I C A T I O N           H O M E        #
###############################################################################

# Remove M3X Backup Online PRO
cd /
if [ -e "/Applications/M3X Backup Online PRO" ]; then
    echo "Remove M3X Backup Online PRO from Your Mac OS X"
    rm -rf "/Applications/M3X Backup Online PRO"
fi

###############################################################################
#        R E M O V E             M A C     O S        R E C E I P T S         #
###############################################################################

# Remove Mac OS X Receipts
if [ -e "/Library/Receipts/obm.pkg" ]; then
    echo "Remove Mac OS X Receipt for obm.pkg (Path: /Library/Receipts/obm.pkg)"
    rm -rf "/Library/Receipts/obm.pkg"
fi
